#include <iostream>
#include <vector>
using namespace std;
int niz1[20];
    vector <int> mat[20];
int main()
{
int a,b,c,i,niz[200000],l,r,t,j;
cin>>a>>b;
for(i=0;i<a;i++)
{
   cin>>niz[i];
}for(j=0;j<b;j++)
{

cin>>l>>r;
for(i=l;i<=r;i++)
{
    if(i==l)t=niz[l-1];
    else t=t&niz[i-1];

}
cout<<t;
}
}